#include <iostream>
#include "histogram.h"
#include "svg.h"
#include <vector>
#include <curl/curl.h>

using namespace std;

struct Input
{
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data(istream& sin, bool prompt)
{
    if (prompt){
        Input in;
        size_t number_count;
        sin >> number_count;
        in.numbers.resize(number_count);
        for (size_t i = 0; i < number_count; i++)
        {
            sin >> in.numbers[i];
        }
        sin >> in.bin_count;
        return in;
    }
    else{
        Input in;
        size_t number_count;
        sin >> number_count;
        in.numbers.resize(number_count);
        for (size_t i = 0; i < number_count; i++)
        {
            sin >> in.numbers[i];
        }
        sin >> in.bin_count;
        return in;
    }
}

int main(int argc, char* argv[]) {
    if (argc > 1) {
        CURL* curl = curl_easy_init();
        auto res = curl_easy_perform(curl);
        if (res != 0) {
            cout << curl_easy_strerror(res);
            exit(1);
        }
        curl_easy_cleanup(curl);
        return 0;
    }
    Input in = input_data(cin, false);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);
    return 0;
}
